unit glmnup;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  opengl, DGlut,Controls, Forms, Dialogs, ExtCtrls, StdCtrls
  ,registry,mmsystem;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    m_1: TLabel;
    m_2: TLabel;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure zastavka;

    procedure help;
    procedure records;
     procedure game;
    procedure drawmenu;
    procedure Read_Registry;
    procedure Write_Registry;
    function  DoSelect(x : GLint; y : GLint) : GLint;
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function  Trassa(x1,y1,x2,y2:byte):boolean;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    newCount, frameCount, lastCount : LongInt;
    fpsRate : GLfloat;
  public
    FIniFile: TRegIniFile;
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation
 const
  SECTION = 'linesscore';

type
pitemsm=^itemsm;
itemsm=record
x,y:glfloat;
s:string;
mode:byte;
action:integer;
//presskey:boolean;
end;
pscreen=^screen;
screen=record
s:byte;
itemsm:tlist;
timer:byte;
end;



//
trecords=record
keyn:integer;
name:string[30];
score:integer;
end;

 //
 thints=record
 x,y:byte;
 color:byte;
 end;
  //
tselect=record
 x,y:byte;
 typeobj:byte;
 end;

 //
tcamera=record
x,y,z,dx,dy:glfloat;
end;

var   DC: HDC;
      hrc: HGLRC;
      //  ObjCylinder1 : GLUquadricObj ;
      t,i:integer;
      colorlist:array[1..10] of tcolor ;
      fontlist:array[1..3] of tfont;
      recordlist:array[1..10] of trecords;
      presskey:char;
      menulist:tlist;
      scrlist:tlist;
      mousex,mousey:integer;
      pagescreen:word=0;
      down:boolean=false;
      kx,ky,kz,cx,cy,cz:array[1..400] of glfloat;
      schy,schc,rx,ry,rz:glfloat;
         vp : Array [0..3] of GLint;
      //   
      hints:array[1..3] of thints;
vsch,a,sch:array[1..9,1..9] of integer;
  selectBuf : Array [0..162] of GLuint;
 xv,yv:byte;
 score,timers:word;
 scorestr:string ;
 animatepath:boolean;
 axp,ayp,apcolor,aypn:byte;
 timestart:tdatetime;
 animate:byte;
 animatecount:glint;
 animatedata:byte;
 playername:string;
 camera1,camera2,camera3:tcamera;
 cameraslist:array[1..5] of tcamera;
 activecamera:byte;
{$R *.DFM}



// 
{$I SetDCPixelFormat}

function PlayResource(lpName:LPCTSTR):boolean;
var
    bRtn:boolean;
    lpRes:LPCTSTR;
    hResInfo, hRes:thandle;

    // Find the WAVE resource.
begin
    hResInfo:= FindResource(hInstance, lpName, 'WAV');
    if (hResInfo = 0) then playresource:=FALSE;

    // Load the WAVE resource.

    hRes := LoadResource(hInstance, hResInfo);
    if (hRes = 0) then
        playresource:=FALSE;
    // Lock the WAVE resource and play it.
    lpRes := LockResource(hRes);
    if (lpRes<>nil) then begin
        bRtn := sndPlaySound(lpRes, SND_ASYNC or SND_MEMORY or SND_NODEFAULT);
        UnlockResource(hRes);
    end
    else
        bRtn:= false;

    // Free the WAVE resource and return success or failure.

    FreeResource(hRes);
    playresource:= bRtn;
end;


procedure tform1.Write_Registry;
begin
 for i:=1 to 10 do begin
  FIniFile.Writeinteger(SECTION, 'key'+inttostr(i),recordlist[i].keyn);
  FIniFile.Writeinteger(SECTION, 'score'+inttostr(i),recordlist[i].score);
  FIniFile.Writestring(SECTION, 'player'+inttostr(i),recordlist[i].Name);
 end;
end;


procedure tform1.Read_Registry;
begin
   for i:=1 to 10 do begin
recordlist[i].keyn:= fIniFile.readinteger(SECTION, 'key'+inttostr(i),0);
recordlist[i].score:= fIniFile.readinteger(SECTION, 'score'+inttostr(i),0);
recordlist[i].name:= FIniFile.readstring(SECTION, 'player'+inttostr(i),'');

 end;
end;

procedure setglcolorf(c:tcolor);
begin
glcolor3f(getrvalue(c)/255,getgvalue(c)/255,getbvalue(c)/255)

end;

procedure setglcolorfa(c:tcolor;a:glfloat);
begin
glcolor4f(getrvalue(c)/255,getgvalue(c)/255,getbvalue(c)/255,a)

end;

 //   
procedure PreOutText(f1:tfont;t:glint);
var
  hOldFont : HFont;
 begin
  hOldFont := SelectObject(DC, f1.Handle);
     wglUseFontBitmaps (dc, 0, 256, t);
 DeleteObject(SelectObject(DC, hOldFont));
 end;



 //   

 procedure OutText (Litera : PChar;t:glint);
begin
   glListBase(t);
  glCallLists(Length (Litera), GL_UNSIGNED_BYTE, Litera);
end;
procedure glow(c:tcolor;x,y,k,t:glfloat;s:string;n:glint);
begin
   // glblendfunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA) ;
      glenable(gl_blend);
    glcolor4f(getrvalue(c)/255+0.2,getgvalue(c)/255+0.2,getbvalue(c)/255+0.2,t);
    glRasterPos2f(x-k,y-k);
      outtext(pchar(s),n);
    glRasterPos2f(x+k,y-k);
      outtext(pchar(s),n);
   glRasterPos2f(x+k,y+k);
      outtext(pchar(s),n);
   glRasterPos2f(x-k,y+k);
      outtext(pchar(s),n);
      gldisable(gl_blend);
end ;


//    Lines ;
procedure textlines(n:glfloat;t:word);
begin

   t:=t div 3;
   glcolor3f(0.1,0.1,0.1);
    glRasterPos2f(0.9,n); outtext('L i N e S',1000);
    glRasterPos2f(1,n);//s:='L i N e S ' ;
   setglcolorf(colorlist[(t+1) mod 5+1]);
     outtext('L       ',1);
      glRasterPos2f(1,n);
   setglcolorf(colorlist[(t+2) mod 5+1]);
     outtext('L i     ',1000);
      glRasterPos2f(1,n);
   setglcolorf(colorlist[(t+3) mod 5+1]);
     outtext('  i      ',1000);  glRasterPos2f(1,n);
   setglcolorf(colorlist[(t+4) mod 5+1]);
     outtext('    N    ',1000);  glRasterPos2f(1,n);
   setglcolorf(colorlist[(t+5) mod 5+1]);
     outtext('      e  ',1000);  glRasterPos2f(1,n);
   setglcolorf(colorlist[(t+7) mod 5+1]);
     outtext('        S',1000);
end;


//   ;
procedure background;
 begin
  // background
   glPushMatrix;
    glLoadIdentity;
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;
    gluOrtho2D(0.0, 1.0, 0.0, 1.0);

    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);
    glBegin(GL_QUADS);

    glColor3f(0.4, 0.8, 0.4);
   // glColor3f((sin(t/10)+1)/2,(cos(t/10)+1)/2,(sin((t/10+200+1)/2));
    glVertex2f(0.0, 0.0);

    glColor3f(0.4, 0.6, 0.6);
     // glColor3f((cos(t/10)+1)/2,(cos(t/10)+1)/2,(sin((t+200)/10+1)/2));

    glVertex2f(1.0, 0.0);
     // glColor3f((cos(t/10)+1)/2,0,(sin((t+200)/10+1)/2));
    glColor3f(0.4, 0.4, 0.8);

    glVertex2f(1.0, 1.0);
       // glColor3f((cos(t/10)*0.5)+0.5,(sin(t/10)),(sin((t/10+200)+1)/2));

    glColor3f(0.9, 0.1, 0.3);

    glVertex2f(0.0, 1.0);
    glEnd;
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);

    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix;
 //end background
 end;



 //   
 procedure setmaterial(ar,ag,ab,dr,dg,db,sr,sg,sb,shine,trans:glfloat);
  var mat:array[0..4] of glfloat;
  begin
   //    
    mat[0]:= ar; mat[1]:= ag; mat[2]:= ab; mat[3] := trans;
    glMaterialfv(GL_FRONT, GL_AMBIENT, @mat);

    //    
    mat[0] := dr; mat[1] :=dg; mat[2] := db;
    glMaterialfv(GL_FRONT, GL_DIFFUSE, @mat);

    //    
    mat[0] := sr; mat[1] := sg; mat[2] := sb;
    glMaterialfv(GL_FRONT, GL_SPECULAR, @mat);
    // shine:=shine*128;
    //    
    glMaterialf(GL_FRONT, GL_SHININESS, shine*128.0);

  end;

  procedure setmateriale(er,eg,eb:glfloat);
  var mat:array[0..4] of glfloat;
  begin
   //    
    mat[0]:= er; mat[1]:= eg; mat[2]:= eb;
    glMaterialfv(GL_FRONT, GL_emission, @mat);
  end;

procedure setglmaterialf(c:tcolor;n:glfloat;d:glint;t:glfloat);
begin
setmaterial(
getrvalue(c)/d,getgvalue(c)/d,getbvalue(c)/d,
getrvalue(c)/d,getgvalue(c)/d,getbvalue(c)/d,
0.9,0.9,0.9,
//getrvalue(c)/d,getgvalue(c)/d,getbvalue(c)/d,
n,t)  end;

procedure setglmateriale(c:tcolor;d:glint);
begin
setmateriale(getrvalue(c)/d,getgvalue(c)/d,getbvalue(c)/d)  end;


procedure TForm1.FormResize(Sender: TObject);
begin
   glViewport(0, 0, width, height);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
scr:pscreen;
itm:pitemsm;
sine,cosine:glfloat;
begin
timers:=100;
//form1.Cursor:=crnone;
 FIniFile := TRegIniFile.Create('Sample Registry');
 Read_Registry;
 if recordlist[1].keyn=0 then
 begin
   for i:=1 to 10 do begin
recordlist[i].keyn :=i;
recordlist[i].score := 0 ;
recordlist[i].name := ' ';

  end;  end;

 lastCount := GetTickCount;
 frameCount := 0;
 timer1.Enabled:=true;
scrlist:=tlist.Create;
//    **
new(scr);
scr.s:=0;
scr.timer:=200;
scr.itemsm:=tlist.Create;
 new(itm);
itm^.x:=14;
itm^.y:=20;
itm^.s:=' ';
itm^.mode:=1;
itm^.action:=3;
scr.itemsm.Add(itm) ;

new(itm);
itm^.x:=11;
itm^.y:=24;
itm^.mode:=1;
itm^.s:='  ';
itm^.action:=1;
scr.itemsm.Add(itm)  ;

new(itm);
itm^.x:=17;
itm^.y:=28;
itm^.mode:=1;
itm^.s:='';
itm^.action:=2;
scr.itemsm.Add(itm);

new(itm);
itm^.x:=18;
itm^.y:=32;
itm^.mode:=1;
itm^.s:='';
itm^.action:=-1;
scr.itemsm.Add(itm);
scrlist.Add(scr);
//   *  *
new(scr);
scr.s:=1;
scr.timer:=50;
scr.itemsm:=tlist.Create;
new(itm);
itm^.x:=18;
itm^.y:=39;
itm^.mode:=1;
itm^.s:=' ';
itm^.action:=0;
scr.itemsm.Add(itm);
scrlist.Add(scr);

//   **
new(scr);
scr.s:=2;
scr.timer:=50;
scr.itemsm:=tlist.Create;
new(itm);
itm^.x:=18;
itm^.y:=39;
itm^.mode:=1;
itm^.s:=' ';
itm^.action:=0;
scr.itemsm.Add(itm);
scrlist.Add(scr);

//   **
new(scr);
scr.s:=3;
scr.timer:=50;
scr.itemsm:=tlist.Create;

new(itm);
itm^.x:=1;
itm^.y:=39.5;
itm^.mode:=2;
itm^.s:='    ';
itm^.action:=-2;
scr.itemsm.Add(itm);
scrlist.Add(scr);
{
new(itm);
itm^.x:=12;
itm^.y:=39.5;
itm^.mode:=2;
itm^.s:='    ';
itm^.action:=0;
scr.itemsm.Add(itm);
scrlist.Add(scr);

new(itm);
itm^.x:=24;
itm^.y:=39.5;
itm^.mode:=2;
itm^.s:='    ';
itm^.action:=0;
scr.itemsm.Add(itm);
scrlist.Add(scr);}

new(itm);
itm^.x:=37;
itm^.y:=39.5;
itm^.mode:=2;
itm^.s:=' - 1';
itm^.action:=-3;
scr.itemsm.Add(itm);
scrlist.Add(scr);


//  
fontlist[1]:=tfont.Create;
fontlist[1].Name :='Courier New';
fontlist[1].size:=48;
fontlist[1].Style:=[fsbold] ;


fontlist[2]:=tfont.Create;
fontlist[2].Name :='Courier New';
fontlist[2].size:=10;
fontlist[2].Style:=[fsbold] ;

fontlist[3]:=tfont.Create;
fontlist[3].Name :='Courier New';
fontlist[3].size:=16;
fontlist[3].Style:=[fsBold] ;

//   
colorlist[1]:=clred;  colorlist[2]:=cllime;colorlist[3]:=clyellow;colorlist[4]:=clblue;
colorlist[5]:=clfuchsia;colorlist[6]:=claqua;colorlist[7]:=clnavy; colorlist[8]:=clolive;
colorlist[9]:=clgreen;colorlist[10]:=clpurple;
// gluLookAt (4,12,8,0, 0,0, 0,1, 0);
cameraslist[1].x:=4; cameraslist[1].y:=10;  cameraslist[1].z:=8;
cameraslist[1].dx:=0;cameraslist[1].dy:=0;

cameraslist[2].x:=4; cameraslist[2].y:=12; cameraslist[2].z:=-8;
cameraslist[2].dx:=0;cameraslist[2].dy:=20;

cameraslist[3].x:=-4; cameraslist[3].y:=11;cameraslist[3].z:=8;
cameraslist[3].dx:=0;cameraslist[3].dy:=0;

//cameraslist[4].x:=0; cameraslist[4].y:=5;cameraslist[4].z:=12;
cameraslist[4].x:=-4; cameraslist[4].y:=14;cameraslist[4].z:=-8;
cameraslist[4].dx:=0;cameraslist[4].dy:=20;

t:=0;
for i:=1 to 400 do begin
kx[i]:=0;
ky[i]:=0;
kz[i]:=0 ;
cx[i]:=random*0.2;
cy[i]:=random*0.3+0.5;
cz[i]:=random*0.2;
end;


DC := GetDC(Handle);
  SetDCPixelFormat(dc);
       hrc := wglCreateContext(DC);
  wglMakeCurrent(DC, hrc);


  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glClearColor (0.25, 0.4, 0.25, 0.0);
  glEnable(GL_NORMALIZE);             //  
  glEnable(GL_DEPTH_TEST);            //   
  glEnable(GL_LIGHTING); //    
  glEnable(GL_LIGHT0);   //    0
 // glEnable(GL_LIGHT1);
//   glEnable(GL_ALPHA_TEST);
   //glAlphaFunc(GL_EQUAL,0.1);

   glNewList(1,GL_COMPILE);
       glutsolidcube(0.4);
  glEndList;
   glNewList(2,GL_COMPILE);
       glutSolidSphere(0.5,10,10) ;
  glEndList;

        //   
         glNewList(3,GL_COMPILE);
         //  setmaterial(0.7,0.7,0.9, 0.9,0.3,0.9,0.9,0.3,0.9,0.7,0.9);
      glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);  // Unfilled mode.
    	glBegin(GL_POLYGON);  // Use polygon to approximate a circle.
		for i:=0 to  5 do
                begin
                        cosine:= 0.1 * cos((i-0.5) * 2 * PI/5.0);
			sine:=   0.1 * sin((i-0.5) * 2 * PI/5.0);
                        glVertex2f(cosine, sine);

                       	cosine:= 0.3 * cos(i * 2 * PI/5.0);
			sine:=   0.3 * sin(i * 2 * PI/5.0);
			  glVertex2f(cosine, sine);

                         cosine:= 0.1 * cos((i+0.5) * 2 * PI/5.0);
			sine:=   0.1 * sin((i+0.5) * 2 * PI/5.0);
                         glVertex2f(cosine, sine);
               end  ;
glEnd();
schy:=5;      schc:=0.5;
   glEndList;

    glNewList(4,GL_COMPILE);
       glutSolidSphere(0.25,10,10) ;
  glEndList;
     glNewList(5,GL_COMPILE);
       glutSolidSphere(0.1,10,10) ;
  glEndList;

   // 



   preouttext(fontlist[1],1000);
  // fontlist[1].Size:=12;
   preouttext(fontlist[2],2000);
   preouttext(fontlist[3],3000);
end;

procedure setcamera(cam:tcamera);
begin
    gluLookAt (cam.x,cam.y,cam.z,0, 0,0, 0,1, 0);
end;

procedure tform1.drawmenu;
var scr,scr2:pscreen;
m:pitemsm;
i:byte;
di,nx,ny:glfloat;
begin

   glPushMatrix;
    glLoadIdentity;
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;
    gluOrtho2D(0.0, 45, 0.0, 40);

    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);
  //  fontlist[1].Size:=12;
  // glcolor3f(0.7,0.4,0.1)        ;
  //preouttext(fontlist[1],1);

scr:=scrlist.Items[pagescreen];
nx:=(45/width)*mousex;
ny:=(40/height)*mousey;
//glrasterpos2f(nx,40-ny);
//glcalllist(4);

for i:=0 to scr.itemsm.Count-1 do begin
m:=scr.itemsm.items[i];
case m.mode of
1:di:=1;
2:di:=2;
end ;

 if (nx>m.x-1) and (nx <m.x+length(m.S)/di+3)
    and ((ny) <m.y-2)
    and ((ny) >m.y-4)
 then begin
 //  
 if down then
 begin down:=false;playresource('select');
 if    m.action<0
then case abs(m.action) of
1:close;
2:begin
animate:=3;
animatecount:=0;end  ;
3:begin m := scr.itemsm.items[i];
 activecamera:=(activecamera) mod 4+1 ;
 animate:=7;animatecount:=1;
 timer1.Enabled:=false;
 timer1.Interval:=20;
 timer1.Enabled:=true;
  m.s:=' - '+inttostr(activecamera);
  scr.itemsm.items[i] :=m;
  end ;
end //case
else
begin t:=0;
pagescreen:=m.action;
scr2:=scrlist.Items[m.action];
timer1.Enabled:=false;
timer1.Interval:=scr2.timer;timers:=scr2.timer;
timer1.Enabled:=true;
end;
 end;

 case m.mode of
  1: begin
  //glow(clblack,m.x,40-m.y,0.1,1,pchar(m.s),3000);
    setglcolorf(claqua) ;
 glrasterpos2f(m.x,40-m.y);
 outtext(pchar(m.s),3000);
glow(claqua,m.x,40-m.y,0.1,0.3,pchar(m.s),3000);

  {setglcolorf(clred) ;
  glrasterpos2f(m.x,40-m.y+0.1);
 outtext(pchar(m.s),3000);
 setglcolorf(clyellow);   }


 end;
 2: begin {setglcolorf(clred) ;
  glrasterpos2f(m.x,40-m.y+0.11);
 outtext(pchar(m.s),2000);
 setglcolorf(clyellow);}
 setglcolorf(claqua) ;
 glrasterpos2f(m.x,40-m.y);
 outtext(pchar(m.s),2000);
glow(claqua,m.x,40-m.y,0.1,0.3,pchar(m.s),2000);


 end;


 end;

 end
  else  case m.mode of
 1: begin
  glow(clblack,m.x,40-m.y,0.1,0.51,pchar(m.s),3000);
 {setglcolorf(clblack) ;
 glrasterpos2f(m.x,40-m.y+0.2);
 outtext(pchar(m.s),3000);}
  setglcolorf(clyellow) ;   end;

 2: begin setglcolorf(clblack) ;
 glrasterpos2f(m.x,40-m.y+0.1);
 outtext(pchar(m.s),2000); setglcolorf(clyellow) ;   end;

 end;

m:=scr.itemsm.items[i];
 case m.mode of
 1: begin
 glrasterpos2f(m.x,40-m.y);
 outtext(pchar(m.s),3000) end;

 2: begin
 glrasterpos2f(m.x,40-m.y);
 outtext(pchar(m.s),2000) end;


  end
 end;


   down:=false;presskey:=#0;
  //  fontlist[1].Size:=48;
  //  preouttext(fontlist[1],1);

glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);

    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix;

end;


procedure tform1.zastavka;
var x,z:integer;
begin
 glPushMatrix;
 // glGetIntegerv(GL_VIEWPORT, @vp);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
    gluPerspective(30.0, width/height, 1.0, 20.0);
   glMatrixMode(GL_MODELVIEW);
  //      
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 //   glMatrixMode (GL_MODELVIEW);
     //   glMatrixMode(GL_PROJECTION);
      glLoadIdentity;
    //  
  background;
  gluLookAt (sin(t/50)*8,12,cos(t/50)*8,{cos(t)}0, 0,0{sin(t)}, 0,1, 0);

  //    -   - 
  //       -   
  setmaterial(0.7,0.7,0.9, 0.9,0.3,0.9,0.9,0.3,0.9,0.7,0.9);
    
    for x:=0 to 8 do  for z:=0 to 8 do  begin //glbegin(GL_QUADS);
  glpushmatrix;
  glTranslatef(x/2-2, 0, z/2-2);
  glCallList(1);
  if random(4)=1 then
  begin
  setmaterial(0.7,0.3,0.9, random,random,0.7,0.9,0.3,0.1,0.7,random);
    glEnable(GL_BLEND);
  glCallList(2);
   gldisable(GL_BLEND);
  end;
  glpopmatrix;
  end;
   glPushMatrix;
    glLoadIdentity;
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;
    gluOrtho2D(0.0, 10.0, 0.0, 10.0);
    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);

    textlines(7.5,t);

    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix;
    glPopMatrix;
    drawmenu;
end;

procedure tform1.help;
var x,z:integer;
s,s1:string;
begin
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 background;
   glPushMatrix;
    glLoadIdentity;
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;
    gluOrtho2D(0.0, 10.0, 0.0, 10.0);
    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);

    textlines(8,t);

    //setglcolorf($00D8B301);
   setglcolorf($0080FFFF);
   glRasterPos2f(1,7.0);
   outtext('      ,',2000);
   glRasterPos2f(1,6.5);
   outtext('          ',2000);
   glRasterPos2f(1,6);
   outtext('     c         ',2000);
   glRasterPos2f(1,5.5);
   outtext(' ',2000);
   setglcolorf(clblack);
   glRasterPos2f(3,5.55);
   outtext('OpenGL',2000);
   setglcolorf($0080FFFF);
   glRasterPos2f(3,5.5);
   outtext('OpenGL',2000);
   glRasterPos2f(1,5.0);
   outtext('    :   ',2000);
   glRasterPos2f(1,4.5);
   outtext('  ,   ,   ',2000);
   glRasterPos2f(1,4.0);
   outtext('5      ,   ',2000);
   glRasterPos2f(1,3.5);
   outtext('  ,   ',2000);
   glRasterPos2f(1,3.0);
   outtext('.             ,   ',2000);
   glRasterPos2f(1,2.5);
   outtext('   ',2000);
   glRasterPos2f(1,2.0);
   outtext(pchar(' : '+m_1.caption+' '),2000);
   glRasterPos2f(1,1.5);
   outtext(pchar(m_2.caption+'  '),2000);
  // end;


    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix;
    glPopMatrix;
    drawmenu;
end;

procedure tform1.records;
var x,z,i:integer; st:string;
scorevrem:trecords;
begin
 if t<3 then begin
 for x:=1 to 10 do for i:=2 to 10 do
 if recordlist[i].score>recordlist[i-1].score
 then begin
 scorevrem:=recordlist[i-1];
 recordlist[i-1]:=recordlist[i] ;
 recordlist[i]:=scorevrem;
 end ;
 for i:=1 to 10 do recordlist[i].keyn:=i
 end;

 glPushMatrix;
 // glGetIntegerv(GL_VIEWPORT, @vp);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
    gluPerspective(70.0, width/height, 1.0, 30.0);
   glMatrixMode(GL_MODELVIEW);
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
      glLoadIdentity;
  // 
  background;
   gluLookAt (10,14,10,{cos(t)}0, 4,0{sin(t)}, 0,1, 0);

  //setmaterial(0.7,0.7,0.9, 0.9,0.3,0.9,0.9,0.3,0.9,0.7,0.9);

if t=1 then  begin
for i:=1 to 300 do begin
kx[i]:=0;
ky[i]:=0;
kz[i]:=0 ;
cx[i]:=random*0.2;
cy[i]:=0.5+random*0.2;
cz[i]:=random*0.2;
end;
  gldisable(GL_CULL_FACE);
end;

   for i:=1 to 300 do begin;
   cx[i]:=cx[i];
   cy[i]:=cy[i]-0.02;
   cz[i]:=cz[i];
   kx[i]:=kx[i]+cx[i];
   ky[i]:=ky[i]+cy[i];
   kz[i]:=kz[i]+cz[i];
   if ky[i]<0 then begin
   kx[i]:=0;
   ky[i]:=0;
   kz[i]:=0;
cx[i]:=random*0.4-0.1;
cy[i]:=0.5+random*0.2;
cz[i]:=random*0.2;
   end;

  glpushmatrix;

  glTranslatef(kx[i], ky[i], kz[i]);
  glrotatef((t*2+i) mod 280,1,0,0);
  setglmaterialf(colorlist[i mod 5+1],0.7,150,1);
  glCallList(3);
  glpopmatrix;
  end;
  glPushMatrix;
    glLoadIdentity;
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;
    gluOrtho2D(0.0, 10.0, 0.0, 10.0);
    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);


   textlines(8,t);

      for i:=1 to 10 do
     begin
     setglcolorf(clyellow);
     glRasterPos2f(2,7-i/2);
     st:=recordlist[i].name;
     outtext(pchar(inttostr(recordlist[i].keyn)),2000);

     glRasterPos2f(3,7-i/2);
     outtext(pchar(st),2000);


     glRasterPos2f(7,7-i/2);
     outtext(pchar(inttostr(recordlist[i].score)),2000);

     end ;


    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix;
    glPopMatrix;
    drawmenu;
end;

  //   
//   
function ifgran(x,y:integer):boolean;
 begin
 ifgran:=false;
 if (x>=1) and (x<10) and (y>=1) and (y<10) then ifgran:=true;
 end;
procedure zapoln(x,y,s:integer);
begin
if ifgran(x+1,y) and (sch[x+1,y]=0) and (a[x+1,y]=0) then a[x+1,y]:=s;
if ifgran(x-1,y) and (sch[x-1,y]=0) and (a[x-1,y]=0) then a[x-1,y]:=s;
if ifgran(x,y+1)  and (sch[x,y+1]=0) and (a[x,y+1]=0) then a[x,y+1]:=s;
if ifgran(x,y-1)  and (sch[x,y-1]=0) and (a[x,y-1]=0) then a[x,y-1]:=s;
end;

function tform1.Trassa(x1,y1,x2,y2:byte):boolean;
var st:string;
d,c,i:integer;
x,y,xt,yt,kol:byte;
begin
for x:=1 to 9 do for y:=1 to 9 do a[x,y]:=0;
kol:=0;
for x:=1 to 9 do for y:=1 to 9 do if sch[x,y]=0 then kol:=kol +1;
a[x1,y1]:=-1;
for i:=1 to kol do begin
for x:=1 to 9 do for y:=1 to 9 do   begin
if a[x,y]=-1 then zapoln(x1,y1,1);
if (a[x,y]>0)  then zapoln(x,y,a[x,y]+1);
end;
//for xt:=1 to 9 do for yt:=1 to 9 do  stringgrid1.cells[xt-1,yt-1]:=inttostr(a[xt,yt]);stringgrid1.Refresh;showmessage('dfgfd');

end;
if a[x2,y2]>0 then trassa:=true else trassa:=false;
if a[x2,y2]>0 then begin
i:=a[x2,y2];
while (a[x2,y2]<>-1) do begin
if ifgran(x2-1,y2) and (a[x2-1,y2]=i-1) and (i-1<>0)  then  x2:=x2-1 else
if ifgran(x2+1,y2) and (a[x2+1,y2]=i-1) and (i-1<>0) then  x2:=x2+1 else
if ifgran(x2,y2-1) and (a[x2,y2-1]=i-1) and (i-1<>0) then  y2:=y2-1 else
if  ifgran(x2,y2+1) and (a[x2,y2+1]=i-1) and (i-1<>0) then  y2:=y2+1;
i:=a[x2,y2]; a[x2,y2]:=-2;
if ifgran(x2-1,y2) and (a[x2-1,y2]=-1) then  x2:=x2-1 else
if ifgran(x2+1,y2) and (a[x2+1,y2]=-1) then  x2:=x2+1 else
if ifgran(x2,y2-1) and (a[x2,y2-1]=-1) then  y2:=y2-1 else
if ifgran(x2,y2+1) and (a[x2,y2+1]=-1) then  y2:=y2+1;

end;end;


end;



//  
function linesdel(xs,ys:byte):boolean;
var
t,k,x,y:byte;
a:array[0..9] of byte;
begin
//   
for y:=0 to 9 do  a[y]:=0;
for y:=1 to 9 do  for x:=1 to 9 do
vsch[x,y]:=0;
linesdel:=false;
//  
for x:=0 to 9 do if x>0 then
if sch[x,ys]<>0 then
if (sch[x,ys]=sch[x-1,ys])
then a[x]:=a[x-1]+1
else a[x]:=1 else
a[x]:=1  ;
for x:=9 downto 0 do if a[x]>4 then for i:=0 to a[x]-1 do
begin
vsch[x-i,ys]:=-1 ;
linesdel:=true;
end;
for y:=0 to 9 do  a[y]:=0;

//  
for y:=0 to 9 do
if y>0 then
if sch[xs,y]<>0 then
if (sch[xs,y]=sch[xs,y-1])
then a[y]:=a[y-1]+1
else a[y]:=1 else
a[y]:=1  ;
for y:=9 downto 0 do if a[y]>4 then for i:=0 to a[y]-1 do
begin
linesdel:=true;
vsch[xs,y-i]:=-1;
end;
t:=0;

for y:=0 to 9 do  a[y]:=0;

//   
if xs=ys then begin x:=1 ;y:=1;t:=9 end;
if xs>ys then begin x:=xs-ys+1;y:=1;t:=9-x+1 end;
if xs<ys then begin x:=1;y:=ys-xs+1;t:=9-y+1 end;

for i:=0 to t do
if sch[x+i,y+i]<>0 then
if (sch[x+i,y+i]=sch[x+i-1,y+i-1])
then a[i]:=a[i-1]+1
else a[i]:=1 else
a[i]:=1 ;
for k:=t downto 0 do if a[k]>4 then
for i:=0 to a[k]-1 do
begin
linesdel:=true;   vsch[x+k-i,y+k-i]:=-1;end;t:=0;

for y:=0 to 9 do  a[y]:=0;

//   
xs:=10-xs;
if xs=ys then begin x:=1 ;y:=1;t:=9 end;
if xs>ys then begin x:=xs-ys+1;y:=1;t:=9-x+1 end;
if xs<ys then begin x:=1;y:=ys-xs+1;t:=9-y+1 end;

x:=10-x;
for i:=0 to t-1 do
//vsch[x-i,(y+i)]:=-1;
if sch[x-i,(y+i)]<>0 then
if (sch[x-i,(y+i)]=sch[x-i+1,(y+i-1)])
then a[i]:=a[i-1]+1
else a[i]:=1 else
a[i]:=1 ;
for k:=t downto 0 do if a[k]>4 then
for i:=0 to a[k]-1 do
begin
linesdel:=true;   vsch[x-k+i,y+k-i]:=-1;end;t:=0;
end;

function getscorestr(scr:word):string;
var i:byte;
s1,s2:string[11];
begin
s1:='0 0 0 0  ';

if scr<>0 then begin
s2:=inttostr(scr);
for i:=1 to length(s2) do
begin
s1[9-(i*2)]:=s2[length(s2)+1-i];
end end;
getscorestr:=s1;
end ;
 // 
procedure showdelete;
var x,y:byte;
begin

for x:=1 to 9 do for y:=1 to 9 do if vsch[x,y]=-1 then
begin
animatedata:=sch[x,y];
sch[x,y]:=0;
score:=score+1;
animate:=1;
animatecount:=0;
end;
if animate=1 then Playresource('deletesch');
//playresource('lobrkdrm') ;
end;

//       
function ifhint(t,c:byte):boolean;
var i:byte;
begin
ifhint:=false;
if t>1 then
for i:=1 to t-1 do if hints[i].color=c
then ifhint:=true;
end;

//       
function ifendgame:byte;
var c,x,y:byte;
begin
c:=0;
for x:=1 to 9 do for y:=1 to 9 do
if sch[x,y]=0 then c:=c+1;
ifendgame:=c;
end;

// 
procedure inithint;
var i:byte;
begin
if ifendgame>1 then
for i:=1 to 3 do begin
repeat
hints[i].x:=random(9)+1;
hints[i].y:=random(9)+1;
hints[i].color:=(random(6)+1);
until (sch[hints[i].x,hints[i].y]=0)
and ifgran(hints[i].x,hints[i].y)
and not(ifhint(i,hints[i].color))
 ;
end else if score>recordlist[10].score then animate:=4 else
animate:=5;
end;

// 
procedure showhint;
var i,x,y:byte;
begin
for i:=1 to 3 do begin
if sch[hints[i].x,hints[i].y]=0 then
sch[hints[i].x,hints[i].y]:=hints[i].color;
//showsch(hints[i].x,hints[i].y,hints[i].color);
linesdel(hints[i].x,hints[i].y) ;
end;
showdelete;  Playresource('showhint');
end;

// 
procedure two;
begin
   animate:=2;
   animatecount:=0;
   //showhint;
   //inithint;
end;

procedure animateprocpath;
begin
a[xv,yv]:=-1;
a[axp,ayp]:=0;
playresource('step2');
//if a[axp,ayp]=-1 then a[axp,ayp]:=0 ;
if  ifgran(axp-1,ayp) and (a[axp-1,ayp]<0) then  axp:=axp-1 else
if  ifgran(axp+1,ayp) and (a[axp+1,ayp]<0) then  axp:=axp+1 else
if  ifgran(axp,ayp-1) and (a[axp,ayp-1]<0) then  ayp:=ayp-1 else
if  ifgran(axp,ayp+1) and (a[axp,ayp+1]<0) then  ayp:=ayp+1;

if (axp=xv) and (ayp=yv) then begin
animatepath:=false;
sch[xv,yv]:=apcolor;
if  linesdel(xv,yv ) then begin
showdelete;
xv:=0;yv:=0;
end else two
end;

end;

 procedure Render (mode : GLenum);
var
x,y:byte;
  i : GLuint;    bkcolor:glfloat;
begin
 i:=0;   glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
     {setmaterial(  0.135, 0.2225, 0.1575,
               0.54, 0.89, 0.63,
               0.316228, 0.716228, 0.316228,
               0.1,0.5);
    setmateriale(0.3,0.5,0.15);
   glpushmatrix;
   glscale(15,0.1,15);
  glTranslatef( 0,-2,0 );
         glcalllist(1);
         setmateriale(0,0,0) ;
    glpopmatrix;}

  for y:=1 to 9 do for x:=1 to 9 do
  begin i:=i+1;

  bkcolor:=(trunc(abs(x-4.5)+abs(y-4.5)))/5  ;
    If mode = GL_SELECT    then glLoadName(i); //   
   if (x=xv) and (y=yv) then begin
   setmaterial(0.7,0.7,0.9, 0.9/bkcolor,0.3/bkcolor,0.9/bkcolor,0.9,0.3,0.9,0.7,0.9);
   setmateriale(0.9/bkcolor,0.3/bkcolor,0.9/bkcolor) end

   else
   setmaterial(0.7,0.7,0.9, 0.9/bkcolor,0.3/bkcolor,0.9/bkcolor,0.9,0.3,0.9,0.7,0.5);

   ///
   if (a[x,y]<0) and animatepath
   and (animate<>3)
    then  begin
   setmaterial(  0.135, 0.2225, 0.1575,
               0.54, 0.89, 0.63,
               0.316228, 0.716228, 0.316228,
               0.1,0.5);
    setmateriale(0.3,0.5,0.15);end;
   glpushmatrix;
  glTranslatef( x/2-2.5,0,y/2-2.5 );
         glcalllist(1);  //glutsolidcube(0.4);
         setmateriale(0,0,0) ;
    glpopmatrix;
    end;

    if animatepath and (animate<>3)

    then  animateprocpath;

    for y:=1 to 9 do for x:=1 to 9 do
   if (sch[x,y]<>0)  then begin   i:=i+1;
   If mode = GL_SELECT    then glLoadName(i); //   
   if (x=xv) and (y=yv) then
   begin
   setglmaterialf(colorlist[sch[x,y]],0.1,300,1);
   //setglmateriale(colorlist[sch[x,y]],800);
   glpushmatrix;
  glTranslatef( x/2-2.5,0.4+sin(t)*0.2+0.2,y/2-2.5 );
  if sin(t)*0.2+0.2<0.15 then
  glscale(1,0.8,1);
         glcalllist(4);  //glutsolidcube(0.4);
         setmateriale(0,0,0);
    glpopmatrix
   end
   else begin
   setglmaterialf(colorlist[sch[x,y]],0.4,350,0.7);
   glpushmatrix;  glTranslatef( x/2-2.5,0.4,y/2-2.5 );
         glcalllist(4);  //glutsolidcube(0.4);
    glpopmatrix;
  end;
  end;
  if  animatepath and (mode=gl_render)then begin

   setglmaterialf(colorlist[apcolor],0.1,190,0.7);
  glpushmatrix;
  glTranslatef( axp/2-2.5,0.4,ayp/2-2.5 );
         glcalllist(4);  //glutsolidcube(0.4);
    glpopmatrix;

  end;

  if (mode=gl_render)  then
  case animate of
  1:begin animatecount:=animatecount+1;
   for x:=1 to 9 do for y:=1 to 9 do
  if vsch[x,y]=-1 then begin
   setglmaterialf(colorlist[animatedata],0.1,310,0.5-0.1*animatecount);
  glpushmatrix;

 // if animatecount=1 then playresource('lobrkdrm') ;
  glTranslatef( x/2-2.5,0.4,y/2-2.5 );
        glcalllist(4);
    glpopmatrix;  //gldisable(GL_BLEND);
  if animatecount=5 then begin
  animate:=0;
//  sch[x,y]:=0;
  end;   end;  end;

  2:begin animatecount:=animatecount+1;
   for i:=1 to 3 do begin
   setglmaterialf(colorlist[hints[i].color],0.4,330,0.7-(3-i)/10);
   glpushmatrix;
  //glTranslatef( hints[i].x/2-2.5,0.2+0.2/animatecount,hints[i].y/2-2.5 );
  glTranslatef( hints[i].x/2-2.5,0.4/(3-animatecount+1),hints[i].y/2-2.5 );
  //glTranslatef( hints[i].x/2-2.5,0.4,hints[i].y/2-2.5 );
  glscalef(animatecount/3.3,animatecount/3.3,animatecount/3.3);
// glscalef(1,animatecount/2.3,1);

         glcalllist(4);  //glutsolidcube(0.4);
    glpopmatrix;   end;
  if animatecount=3 then begin
  animate:=0;
  showhint;
   //linesdel(hints[i].x,hints[i].y) ;
   //showdelete;
  inithint;
  end;  end;
7:begin animatecount:=animatecount+1;
if animatecount=2 then begin
camera2:=cameraslist[activecamera];
   camera1:=camera3;
   ry:=camera2.y-camera1.y;rx:=camera2.x-camera1.x;
   rz:=camera2.z-camera1.z;
    if camera2.x>camera1.x then
    camera3.x:=camera1.x-(cos(pi/2+animatecount/15)*rx)
  else
  camera3.x:=camera1.x+(cos(pi/2-animatecount/15)*rx);

  if camera2.y>camera1.y then
  camera3.y:=camera1.y-(sin(pi/2+animatecount/15)*ry-ry) else
  camera3.y:=camera1.y-(sin(pi/2-animatecount/15)*ry-ry);


  if camera2.z>camera1.z then
  camera3.z:=camera1.z-(sin(pi/2+animatecount/15)*rz-rz)
   else
  camera3.z:=camera1.z-(sin(pi/2-animatecount/15)*rz-rz);

   end;
   if (abs(camera2.x-camera3.x)>0.5) or
   (abs(camera2.y-camera3.y)>0.5)
or (abs(camera2.z-camera3.z)>0.5)
 then
  begin
  if camera2.x>camera1.x then
  camera3.x:=camera1.x-(cos(pi/2+animatecount/15)*rx)
  else
  camera3.x:=camera1.x+(cos(pi/2-animatecount/15)*rx);

  if camera2.y>camera1.y then
  camera3.y:=camera1.y-(sin(pi/2+animatecount/15)*ry-ry) else
  camera3.y:=camera1.y-(sin(pi/2-animatecount/15)*ry-ry);


  if camera2.z>camera1.z then
  camera3.z:=camera1.z-(sin(pi/2+animatecount/15)*rz-rz)
   else
  camera3.z:=camera1.z-(sin(pi/2-animatecount/15)*rz-rz);
  end
 else
 begin
animate:=0;
form1.timer1.Interval:=50;
end
end;
  end; //case


  if (mode=gl_render) and (animate<>2) then  for i:=1 to 3 do begin
   setglmaterialf(colorlist[hints[i].color],0.4,330,1);
    //setglmateriale(colorlist[hints[i].color],255);
   glpushmatrix;


  glTranslatef( hints[i].x/2-2.5,0.2,hints[i].y/2-2.5 );
         glcalllist(5);  //glutsolidcube(0.4);
         setmateriale(0,0,0);
    glpopmatrix;   end;
    glDisable(GL_BLEND);
end;

function tform1.DoSelect(x : GLint; y : GLint) : GLint;
var
  hits : GLint;
begin

  glSelectBuffer(162, @selectBuf); //   
 glRenderMode(GL_SELECT); //  
 glInitNames;             //   
 glPushName(0);           //     

 glPushMatrix;
 glGetIntegerv(GL_VIEWPORT, @vp);

glMatrixMode(GL_PROJECTION);   //    
    glLoadIdentity;                //     
   //gluPickMatrix(x-5, clientheight-y-22, 2, 2, @vp);
   //gluPickMatrix(x-5, height- y-20, 4, 4, @vp);
    gluPickMatrix(x-5+cameraslist[activecamera].dx, clientheight-(y+cameraslist[activecamera].dy), 4, 4, @vp);
    gluPerspective(25, Width / (Height), 1.0, 30.0);


  glMatrixMode(GL_MODELVIEW);
 // gluLookAt (4,12,8,0, 0,0, 0,1, 0);
 //setcamera(cameraslist[activecamera]);
   setcamera(camera3);
 glClear(GL_COLOR_BUFFER_BIT or   GL_DEPTH_BUFFER_BIT);
  render(GL_select);     //     
     glpopmatrix;
      hits := glRenderMode(GL_RENDER);
  if hits <= 0
     then DoSelect := -1
     else DoSelect := selectBuf[(hits-1)*4+3];
end;

//    
procedure initgame;
var x,y:byte;
begin    randomize;animatepath:=false;
animate:=0;playername:=' ';
timestart:=time;
activecamera:=1;
camera3:=cameraslist[activecamera];
for i:=1 to 3 do begin hints[i].x:=random(8)+1;
hints[i].y:=random(8)+1;hints[i].color:=random(4)+1;end;
for x:=1 to 9 do
for y:=1 to 9 do begin
a[x,y]:=0;sch[x,y]:=0;vsch[x,y]:=0;
;end;
score:=0;scorestr:='0 0 0 0 ';
  glEnable(GL_CULL_FACE);
two;
end;


procedure tform1.game;
var x,z,y,zt:integer;
sel:glint;
xm,ym:byte;
begin  zt:=81;xm:=0;ym:=0;
  if t=1  then initgame;
  //if t=4 then animate:=4;
// 
  glPushMatrix;
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
    gluPerspective(25.0, width/(height), 1.0, 30.0);
   glMatrixMode(GL_MODELVIEW);
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

      glLoadIdentity;

glMatrixMode (GL_PROJECTION);   glLoadIdentity();
   gluPerspective(25, Width / (Height), 1.0, 30.0);
      glMatrixMode (GL_MODELVIEW);
      glLoadIdentity ;
    glClear(GL_COLOR_BUFFER_BIT or   GL_DEPTH_BUFFER_BIT );
     background;

    //setcamera(cameraslist[activecamera]);
// gluLookAt (4,12,8,0, 0,0, 0,1, 0);
// gluLookAt (sin(t/50)*8,12,cos(t/50)*8,{cos(t)}0, 0,0{sin(t)}, 0,1, 0);
     setcamera(camera3);
   glGetIntegerv(GL_VIEWPORT, @vp);
 render(gl_render);
//caption:=inttostr(axp)+'   '+inttostr(ayp)+'  '+inttostr(xv)+'  '+inttostr(yv) ;
   glPopMatrix ;


    glPushMatrix;
    glLoadIdentity;
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;
    gluOrtho2D(0.0, 20.0, 0.0, 24.0);
    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);

     glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
     setglcolorfa($0011AEAE,0.7);
     glRasterPos2f(0.5,21.55);
    outtext(pchar(getscorestr(score)),3000);
     glRasterPos2f(15,21.55);
     //gettime
    // outtext('00 : 07',3000);
     outtext(pchar(timetostr(time-timestart)),3000);
    glEnable(GL_BLEND);
    setglcolorfa(clyellow,0.7);
     glRasterPos2f(0.5,21.5);
     outtext(pchar(getscorestr(score)),3000);


     glRasterPos2f(15,21.5);
     outtext(pchar(timetostr(time-timestart)),3000);
       glDisable(GL_BLEND)  ;

    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix;
    glPopMatrix;

    //   

 if down and (animatepath=false) and (animate=0) then begin
 sel:= doselect(mousex,mousey);
 if (sel>0)  then
 //  
 if sel<82 then begin
 xm:=sel mod 9; if xm=0 then xm:=9;
 ym:=(sel-1)  div 9+1;
 playresource('select');
 end else
 for y:=1 to 9 do for x:=1 to 9 do
  begin
  if sch[x,y]>0
  then begin zt:=zt+1;
  // 
  if zt=sel then begin xm:= x;ym:=y ; playresource('select');end;end;
  end ;
    if sch[xm,ym]>0 then begin
xv:=xm;yv:=ym;end
else
if (xv>0) and (yv>0)
and not((xv=xm) and (yv=ym))
 then
begin
if trassa(xv,yv,xm,ym)  then
begin
animatepath:=true;
axp:=xv;ayp:=yv;
apcolor:=sch[xv,yv];
sch[xv,yv]:=0;
 xv:=xm;yv:=ym
//if  linesdel(xm,ym ) then  showdelete
//else two;
end   else Playresource('noway');
end;
 end;
  sel:=0;

if not (animate  in [3..4]) then       drawmenu;

   if   (animate =3)  then  begin
     if presskey<>#0 then
   if (presskey='l') or (presskey='L') or  (presskey='')
   or  (presskey='') then
   begin
   timer1.Enabled:=false;
   timer1.Interval:=200;
   timer1.Enabled:=true;
   animate:=0;
   t:=0;pagescreen:=0;
   end else animate:=0;

   if ifendgame<2 then begin
   timer1.Enabled:=false;
   timer1.Interval:=200;
   timer1.Enabled:=true;
   animate:=0;
   t:=0;pagescreen:=0;
   end else begin



    glPushMatrix;
    glLoadIdentity;
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;
      glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    gluOrtho2D(0.0, 20.0, 0.0, 24.0);
    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);
       glenable(GL_BLEND);
     //setglcolorfa($0011AEAE,0.4);
     setglcolorfa(clred,0.2);
     glRasterPos2f(1.5,14.1);
     outtext('',1000);
     glRasterPos2f(1.5,10.1);
     outtext(' (/)',1000);

     setglcolorfa(clyellow,0.7);
     glRasterPos2f(1.5,14);
     outtext('',1000);
     glRasterPos2f(1.5,10);
     outtext(' (/)',1000);

     glDisable(GL_BLEND);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix;
    glPopMatrix;
   end ; end;

    if   (animate =4)  then  begin
     if presskey<>#0 then
   case  ord(presskey) of
   13:begin
   timer1.Enabled:=false;
   timer1.Interval:=50;
   timer1.Enabled:=true;
   animate:=0;
   recordlist[10].name:=playername;
   recordlist[10].score:=score;
   t:=0;pagescreen:=2;
   end;
   8:if length(playername)>0 then playername:=copy(playername,1,length(playername)-1);
   65..254:if length(playername)<22 then playername:=playername+presskey;
   //129..175:if length(playername)<20 then playername:=playername+presskey;
   32:if length(playername)<22 then playername:=playername+presskey;

   end;
  presskey:=#0;



    glPushMatrix;
    glLoadIdentity;
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;
      glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    gluOrtho2D(0.0, 20.0, 0.0, 24.0);
    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);
       glenable(GL_BLEND);
       setglcolorfa(clyellow,0.3);
        glRectf(1,10 , 19,16 );

        setglcolorfa(clblack,0.5);
        glRectf(2,11.1 , 18,12.9 );
         
         setglcolorfa(clyellow,1);glRasterPos2f(3,14);
     outtext('      ',3000);
       if (t mod 10)>5 then begin
     //setglcolorfa($0011AEAE,0.4);
  //   setglcolorfa(clred,0.2);
    // glRasterPos2f(1.5,14.1);
    // outtext(pchar(playername),3000);
         setglcolorfa(clyellow,0.7);
     glRasterPos2f(1.5,11.8);
     outtext(pchar(playername),3000);end
     else begin
    // setglcolorfa(clred,0.2);
     //glRasterPos2f(1.5,14.1);
    /// outtext(pchar(playername+'|'),3000);
         setglcolorfa(clyellow,0.7);
     glRasterPos2f(1.5,11.8);
     outtext(pchar(playername+'|'),3000);

     end;

     glDisable(GL_BLEND);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix;
    glPopMatrix;
   end ;

   if animate=5 then
   begin
   glPushMatrix;
    glLoadIdentity;
    glMatrixMode(GL_PROJECTION);
    glPushMatrix;
    glLoadIdentity;
      glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    gluOrtho2D(0.0, 20.0, 0.0, 24.0);
    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST);
       glenable(GL_BLEND);
     //setglcolorfa($0011AEAE,0.4);
     setglcolorfa(clblue,0.3);
     glRasterPos2f(2,14.1);
     outtext('  ',1000);
     glRasterPos2f(2,10.1);
     outtext(' ',1000);

     setglcolorfa(clyellow,0.8);
     glRasterPos2f(2,14);
     outtext('  ',1000);
     glRasterPos2f(2,10);
     outtext('',1000);

     glDisable(GL_BLEND);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix;
    glPopMatrix;
end;

end;

procedure TForm1.FormPaint(Sender: TObject);
var x,z,t1,t2:integer;
framesec:glfloat;
 ps : TPaintStruct;
begin
  BeginPaint(Handle, ps);
  case pagescreen of
  0:zastavka;
  1:help;
  2:records;
  3:game;
  end;
  SwapBuffers(DC);

  //FPS
  endPaint(Handle, ps);
   newCount := GetTickCount;
 Inc(frameCount);
 If (newCount - lastCount) > 1000 then  begin //  
    fpsRate := frameCount * 1000 / (newCount - lastCount);
    Caption := 'FPS - ' + FloatToStr (fpsRate);
    lastCount := newCount;
    frameCount := 0;
   end;
 {  framesec:=1000 div timers;
 if t>5 then begin
 timer1.Enabled:=false;
 t1:=trunc(timers/framesec/fpsrate*1.5);
 if t1<1 then t1:=1;
 timer1.Interval:=t1;
 timer1.Enabled:=true;
  end;
   caption:=inttostr(trunc(t1))+'    '+inttostr(timers)+'   '+floattostr(framesec)+'   '+floattostr(fpsrate)+'   ';}
      end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
InvalidateRect(Handle, nil, False);
 t:=t+1;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Timer1.Enabled := False;
 Write_Registry;
  wglMakeCurrent(0, 0);
  wglDeleteContext(hrc);
  ReleaseDC(Handle, DC);
  //gluDeleteQuadric (ObjCylinder1);
  glDeleteLists (1, 2);
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
mousex:=x;mousey:=y;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
mousex:=x;mousey:=y;
down:=true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
timer1.Enabled:=false;
action:=cafree;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
presskey:=key;
end;

end.
